import processing.serial.*;
import ddf.minim.*;

Serial serial;
Minim minim;
AudioSample ding;
int ball_x, ball_y, ball_dx, ball_dy, ball_size;
int racket_x, racket_y, racket_width, racket_height;
int xmin, xmax, ymin, ymax;
int s, high_byte, low_byte;
int state;

void setup()
{
  size(240, 320);
  frameRate(30);
  
  serial = new Serial(this, "COM1", 9600);
  
  minim = new Minim(this);
  ding = minim.loadSample("ding.wav");
  
  ball_size = 20;
  
  xmin = ball_size / 2;
  ymin = ball_size / 2;
  xmax = width - ball_size / 2;
  ymax = height - ball_size / 2;
  
  ball_x = (int)random(xmin, xmax);
  ball_y = 50;
  ball_dx = 5;
  ball_dy = 5;
  
  racket_width = 80;
  racket_height = 12;
  racket_x = width / 2 - racket_width / 2;
  racket_y = height - 50;
  
  s = 1;
  state = 0;
}

void draw()
{
  if (state == 0)
  {
    background(0, 0, 255);
    fill(255, 255, 255);
    textSize(28);
    textAlign(CENTER);
    text("click to start", 120, 160);
  }
  else
  {
    background(0, 0, 255);
    
    if (serial.available() >= 2)
    {
      high_byte = serial.read();
      low_byte = serial.read();
      racket_x = (high_byte << 8) + low_byte;
      
      serial.write(s);
    }
    
    ball_x += ball_dx;
    if (ball_x <= xmin)
    {
      ding.trigger();
      ball_dx *= -1;
      ball_x = xmin + (xmin - ball_x);
    }
    if (ball_x >= xmax)
    {
      ding.trigger();
      ball_dx *= -1;
      ball_x = xmax - (ball_x - xmax);
    }
    
    ball_y += ball_dy;
    if (ball_y <= ymin)
    {
      ding.trigger();
      ball_dy *= -1;
      ball_y = ymin + (ymin - ball_y);
    }
    if (ball_y >= ymax)
    {
      ding.trigger();
      delay(2000);
      ball_x = (int)random(xmin, xmax);
      ball_y = 50;
      state = 0;
    }
    if (ball_y - ball_dy <= racket_y - ball_size / 2
      && ball_y >= racket_y - ball_size / 2
      && ball_x >= racket_x
      && ball_x <= racket_x + racket_width)
    {
      ding.trigger();
      ball_dy *= -1;
      ball_y = racket_y - ball_size / 2
        - (ball_y - (racket_y - ball_size / 2));
    }
    
    noStroke();
    fill(255, 255, 255);
    ellipse(ball_x, ball_y, ball_size, ball_size);
    
    if (racket_x > width - racket_width)
    {
      racket_x = width - racket_width;
    }
    rect(racket_x, racket_y, racket_width, racket_height);
  }
}

void mousePressed()
{
  serial.write(s);
  state = 1;
}

void stop()
{
  ding.close();
  minim.stop();
  super.stop();
}
